/* /////////////////////////////////////////////////////////////////////////////
 * File:        stlsoft_typefixer_reference.h
 *
 * Purpose:     Definition of the fixer_reference and fixer_reference_type types.
 *
 * Created:     9th February 2004
 * Updated:     9th February 2004
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Source License)
 *
 *              Copyright (C) 2002-2003, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/stlsoft
 *                          http://www.stlsoft.org/
 *
 *              email:      submissions@stlsoft.org  for submissions
 *                          admin@stlsoft.org        for other enquiries
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (iv) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _STLSOFT_INCL_H_STLSOFT_ITERATOR
# error This file must not be included independently of stlsoft_iterator.h
#endif /* !_STLSOFT_INCL_H_STLSOFT_ITERATOR */

#ifndef __STLSOFT_CF_TEMPLATE_PARTIAL_SPECIALISATION_SUPPORT
# error This file cannot be included by compilers that do not support partial template specialisation
#endif // !__STLSOFT_CF_TEMPLATE_PARTIAL_SPECIALISATION_SUPPORT

/* ////////////////////////////////////////////////////////////////////////// */

#define _STLSOFT_VER_H_STLSOFT_TYPEFIXER_REFERENCE_MAJOR    1
#define _STLSOFT_VER_H_STLSOFT_TYPEFIXER_REFERENCE_MINOR    0
#define _STLSOFT_VER_H_STLSOFT_TYPEFIXER_REFERENCE_REVISION 1
#define _STLSOFT_VER_H_STLSOFT_TYPEFIXER_REFERENCE_EDIT     1

/* /////////////////////////////////////////////////////////////////////////////
 * Types
 */

// Uses the "reference" member type, if present
template <typename T, ss_bool_t>
struct fixer_reference
{
    typedef ss_typename_type_k T::value_type    value_type;
    typedef ss_typename_type_k T::reference       reference;
};

// When not present it uses void as a placeholder
template <typename T>
struct fixer_reference<T, false>
{
    typedef void                                value_type;
    typedef void                                reference;
};


// Uses the "reference_type" member type, if present
template <typename T, ss_bool_t>
struct fixer_reference_type
{
    typedef ss_typename_type_k T::value_type    value_type;
    typedef ss_typename_type_k T::reference_type  reference;
};

// When not present it uses void as a placeholder
template <typename T>
struct fixer_reference_type<T, false>
{
    typedef void                                value_type;
    typedef void                                reference;
};

/* ////////////////////////////////////////////////////////////////////////// */
