/* /////////////////////////////////////////////////////////////////////////////
 * File:        stlsoft_zerodef.h
 *
 * Purpose:     Include for defining ZERO to be the ZERO_v template class.
 *
 * Created:     29th July 2003
 * Updated:     16th October 2003
 *
 * Author:      Matthew Wilson, Synesis Software Pty Ltd.
 *
 * License:     (Licensed under the Synesis Software Standard Source License)
 *
 *              Copyright (C) 2002-2003, Synesis Software Pty Ltd.
 *
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/stlsoft
 *                          http://www.stlsoft.org/
 *
 *              email:      submissions@stlsoft.org  for submissions
 *                          admin@stlsoft.org        for other enquiries
 *
 *              Redistribution and use in source and binary forms, with or
 *              without modification, are permitted provided that the following
 *              conditions are met:
 *
 *              (i) Redistributions of source code must retain the above
 *              copyright notice and contact information, this list of
 *              conditions and the following disclaimer.
 *
 *              (ii) Any derived versions of this software (howsoever modified)
 *              remain the sole property of Synesis Software.
 *
 *              (iii) Any derived versions of this software (howsoever modified)
 *              remain subject to all these conditions.
 *
 *              (iv) Neither the name of Synesis Software nor the names of any
 *              subdivisions, employees or agents of Synesis Software, nor the
 *              names of any other contributors to this software may be used to
 *              endorse or promote products derived from this software without
 *              specific prior written permission.
 *
 *              This source code is provided by Synesis Software "as is" and any
 *              warranties, whether expressed or implied, including, but not
 *              limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software be liable for any direct, indirect,
 *              incidental, special, exemplary, or consequential damages
 *              (including, but not limited to, procurement of substitute goods
 *              or services; loss of use, data, or profits; or business
 *              interruption) however caused and on any theory of liability,
 *              whether in contract, strict liability, or tort (including
 *              negligence or otherwise) arising in any way out of the use of
 *              this software, even if advised of the possibility of such
 *              damage.
 *
 * ////////////////////////////////////////////////////////////////////////// */


#ifndef _STLSOFT_INCL_H_STLSOFT_ZERODEF
#define _STLSOFT_INCL_H_STLSOFT_ZERODEF

#ifndef __STLSOFT_DOCUMENTATION_SKIP_SECTION
#define _STLSOFT_VER_H_STLSOFT_ZERODEF_MAJOR    1
#define _STLSOFT_VER_H_STLSOFT_ZERODEF_MINOR    0
#define _STLSOFT_VER_H_STLSOFT_ZERODEF_REVISION 3
#define _STLSOFT_VER_H_STLSOFT_ZERODEF_EDIT     4
#endif /* !__STLSOFT_DOCUMENTATION_SKIP_SECTION */

/* /////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#ifndef _STLSOFT_INCL_H_STLSOFT
# include "stlsoft.h"       // Include the STLSoft root header
#endif /* !_STLSOFT_INCL_H_STLSOFT */
#ifndef _STLSOFT_INCL_H_STLSOFT_ZERO
# include "stlsoft_zero.h"   // Include the STLSoft root header
#endif /* !_STLSOFT_INCL_H_STLSOFT_ZERO */

#include <stddef.h> // Always make sure that this is included, irrespective of
                    // its potential inclusion within stlsoft.h

/* /////////////////////////////////////////////////////////////////////////////
 * Definitions
 */

#ifdef ZERO
# ifdef _STLSOFT_COMPILE_VERBOSE
#  pragma message("ZERO is already defined in this compilation unit. Continuing is potentially dangerous. You are advised to verify that the redefinition is compatible, or to refrain from using stlsoft_zerodef.h")
# endif /* _STLSOFT_COMPILE_VERBOSE */
#endif /* !ZERO */

#ifdef __cplusplus
# ifdef ZERO
#  undef ZERO
# endif /* ZERO */
 /// \def ZERO
 ///
 /// By including this file, \c ZERO is (re-)defined to be <code>stlsoft::ZERO_v()</code>
 /// which means that any use of \c ZERO must be with integral types.
# define ZERO   stlsoft_ns_qual(ZERO_v)::create()
#endif /* __cplusplus */

/* ////////////////////////////////////////////////////////////////////////// */

#endif /* !_STLSOFT_INCL_H_STLSOFT_ZERODEF */

/* ////////////////////////////////////////////////////////////////////////// */
